// zmienne globalne
var przewWlaczone = false;
var interwalPrzew;
var paskiPrzew = new Array();

// odczyt rzeczywistych wartoci wasnoci stylu
function stylElementu(IdElem, WlasnoscStyluIE, WlasnoscStyluCSS) {
    var elem = document.getElementById(IdElem);
    if (elem.currentStyle) {
        return elem.currentStyle[WlasnoscStyluIE];
    } else if (window.getComputedStyle) {
        var styl = window.getComputedStyle(elem, "");
        return styl.getPropertyValue(WlasnoscStyluCSS);
    }
    return "";
}

// konstruktor obiektu
function pasekPrzew(idWlasc, idWlascTresci, idWGore, idWDol) {
    this.idWlasc = idWlasc;
    this.idWlascTresci = idWlascTresci;
    this.indeks = paskiPrzew.length;
    this.przycWGore = document.getElementById(idWGore);
    this.przycWDol = document.getElementById(idWDol);
    this.przycWGore.indeks = this.indeks;
    this.przycWDol.indeks = this.indeks;
    
    this.wysWlasc = parseInt(stylElementu(this.idWlasc, "height", "height"));

    this.elemTresci = document.getElementById(idWlascTresci);
    this.rozmCzcionkiTresci = parseInt(stylElementu(this.idWlascTresci, 
        "fontSize", "font-size"));
    this.wysPrzewTresci = (this.elemTresci.scrollHeight) ? 
        this.elemTresci.scrollHeight : this.elemTresci.offsetHeight;
    this.inicjujPrzewijanie = inicjujPrzewijanie;
}

// przypisanie przyciskom przewijania funkcji obsugi zdarze
function inicjujPrzewijanie() {
    this.przycWGore.onmousedown = kliknieciePrzew;
    this.przycWGore.onmouseup = zatrzymaniePrzew;
    this.przycWGore.oncontextmenu = blokadaZdarzenia;

    this.przycWDol.onmousedown = kliknieciePrzew;
    this.przycWDol.onmouseup = zatrzymaniePrzew;
    this.przycWDol.oncontextmenu = blokadaZdarzenia;
    
    var isIEMac = (navigator.appName.indexOf("Explorer") != -1 && navigator.userAgent.indexOf("Mac") != -1);
    if (!isIEMac) {
        document.getElementById("wewElem0").style.overflow = "hidden";
    }
}

/*************************
  funkcje obsugi zdarze
**************************/
// wyczenie przewijania
function zatrzymaniePrzew() {
    przewWlaczone = false;
}

//  niedopuszczenie do wywietlenia menu kontekstowego w systemach Macintosh 
// (przy przytrzymaniu przycisku myszy)
function blokadaZdarzenia(zdarzenie) {
    zdarzenie = (zdarzenie) ? zdarzenie: event;
    zdarzenie.cancelBubble = true;
    return false;
}

// rozpoczcie przewijania treci w kierunku zalenym od
// kliknitego przycisku (w gr lub w d)
function kliknieciePrzew(zdarzenie) {
    var rozmCzcionki;
    zdarzenie = (zdarzenie) ? zdarzenie: event;
    var cel = (zdarzenie.target) ? zdarzenie.target : zdarzenie.srcElement;
    var indeks = cel.indeks;
    rozmCzcionki = paskiPrzew[indeks].rozmCzcionkiTresci;
    rozmCzcionki = (cel.className == "liniaWGore") ? rozmCzcionki : -rozmCzcionki;
    przewWlaczone = true;
    // przewijanie dla pojedynczego klinicia
    przewinO(indeks, parseInt(rozmCzcionki));
    // uruchomienie przewijania przy przytrzymaniu przycisku myszy
    interwalPrzew = setInterval("przewinO(" + indeks + ", " + 
        parseInt(rozmCzcionki) + ")", 100);
    zdarzenie.cancelBubble = true;
    return false;
}

// przewinicie treci jednorazowo lub cyklicznie (za pomoc funkcji setInterval())
function przewinO(indeks, px) {
    var pasek = paskiPrzew[indeks];
    var elem = document.getElementById(pasek.idWlascTresci);
    var gora = parseInt(elem.style.top);
    var wysPrzew = parseInt(pasek.wysPrzewTresci);
    var wys = pasek.wysWlasc;
    if (przewWlaczone && gora + px >= -wysPrzew + wys && gora + px <= 0) {
        przesun(elem, 0, px);
    } else {
        clearInterval(interwalPrzew);
    }
}
